<script setup lang="ts">
  import { Swiper, SwiperSlide } from 'swiper/vue';
  import { SwiperOptions } from 'swiper/types';
  import type { CustomSliderElementConfig } from '@shopware-pwa/composables-next';
  import { Pagination } from 'swiper/modules';
  import cloneDeep from 'lodash/cloneDeep';

  const props = withDefaults(
    defineProps<{
      config?: CustomSliderElementConfig;
      sliderOptions?: SwiperOptions;
    }>(),
    {
      config: undefined,
      sliderOptions: undefined,
    },
  );
  const slots = useSlots();
  const childrenRaw = computed(() => (slots?.default?.()[0].children as any) ?? []);

  const swiperRef = ref<typeof Swiper>();

  const setSwiper = (swiper: any) => {
    swiperRef.value = swiper;
  };

  const slideNext = () => {
    swiperRef.value?.slideNext();
  };

  const slidePrev = () => {
    swiperRef.value?.slidePrev();
  };

  const attrs = computed<any>(() => {
    const temp: SwiperOptions = {
      modules: [],
      autoHeight: true,
      rewind: true,
      slidesPerView: 1,
      spaceBetween: 8,
    };
    if (props.config?.rotate?.value || props.config?.autoSlide?.value) {
      temp.modules?.push(SwiperAutoplay);
      temp.autoplay = {
        delay: props.config?.autoplayTimeout?.value || 5000,
        disableOnInteraction: true,
      };
      temp.speed = props.config?.speed?.value || 300;
    }
    if (props.config?.navigationDots?.value) {
      temp.modules?.push(Pagination);
      temp.pagination = {
        clickable: true,
      };
    }

    const propsProcessor = cloneDeep(props.sliderOptions);

    if (typeof temp.slidesPerView === 'number' && childrenRaw.value?.length < temp.slidesPerView) {
      temp.slidesPerView = childrenRaw.value?.length;
    }
    if (propsProcessor?.breakpoints) {
      Object.entries(propsProcessor?.breakpoints).forEach(([key, value]) => {
        if (
          typeof value.slidesPerView === 'number' &&
          value?.slidesPerView > childrenRaw.value?.length &&
          propsProcessor.breakpoints
        ) {
          propsProcessor.breakpoints[key].slidesPerView = childrenRaw.value?.length;
        }
      });
    }

    return { ...temp, ...propsProcessor };
  });

  defineExpose({ sliderRef: swiperRef });
</script>
<template>
  <div class="relative flex items-center gap-2 md:gap-3 lg:gap-4">
    <div
      v-if="config?.navigationArrows?.value"
      :class="{
        'absolute left-0 top-1/2 z-50 -translate-y-1/2 transform':
          config?.navigationArrows?.value === 'inside',
      }"
    >
      <button
        class="border-border hover:enabled:bg-interactive-hover active:enabled:bg-interactive-pressed disabled:text-information-disabled rounded-md border bg-white px-2 py-6"
        @click="slidePrev"
      >
        <span class="i-sw-solid:chevron-left-s text-base" />
      </button>
    </div>
    <Swiper
      :class="{
        'pb-10': config?.navigationDots?.value === 'outside',
      }"
      v-bind="attrs"
      @swiper="setSwiper"
    >
      <SwiperSlide v-for="(child, index) of childrenRaw" :key="index">
        <Component :is="child" />
      </SwiperSlide>
    </Swiper>
    <div
      v-if="config?.navigationArrows?.value"
      :class="{
        'absolute right-0 top-1/2 z-50 -translate-y-1/2 transform':
          config?.navigationArrows?.value === 'inside',
      }"
    >
      <button
        class="border-border hover:enabled:bg-interactive-hover active:enabled:bg-interactive-pressed disabled:text-information-disabled rounded-md border bg-white px-2 py-6"
        @click="slideNext"
      >
        <span class="i-sw-solid:chevron-right-s text-base" />
      </button>
    </div>
  </div>
</template>
